/*
	$Id: CompoundMember.java 263 2006-08-16 18:50:56Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import java.io.PrintWriter;

/**
   ¤ΤΥФޤ϶ΤΥФΤstructޤunionޤ
   enumΥФǤ

   Υ饹ɽФϥѥɥФȸƤӤޤΥФ
   ƤϹ¤Τޤ϶ΤǤ

   structmemberǡunionmemberǡenummemberǤбޤ
*/
public abstract class CompoundMember extends Member implements Compound {

    /** ι¤Τޤ϶ΤΰѾ */
    private CompoundImpl impl;

    /**
       ѥɥФޤ

       @param parentName Ƥ̾
       @param type type°
       @param elem structmemberǤޤunionmemberǤޤ
       enummember
    */
    protected CompoundMember(final String parentName, final String type,
			     final Element elem) {
	super(parentName, type, elem);
	impl = null;
    }

    /**
       ѥɤμꤷޤ

       @param impl ѥɤμ
    */
    protected void setCompoundImpl(final CompoundImpl impl) {
	this.impl = impl;
    }

    /**
       ѥɤޤ

       @param c ȤʤǤλҥΡɥե륿
       @return ѥɤ
    */
    protected static Description getDescription(final ChildrenFilter c) {
	NodeList tagNodes = c.getDirectChildrenByTagName("tag");
	if (tagNodes.getLength() == 0) {
	    return new Description();
	}
	ChildrenFilter gc = new ChildrenFilter((Element) tagNodes.item(0));
	NodeList descNodes = gc.getDirectChildrenByTagName("desc");
	return new Description(descNodes);
    }

    /**
       {@inheritDoc}
    */
    @Override public void printCode(final PrintWriter wr,
				    final String indent) {
	wr.println(indent + type + " {");
	String nextIndex = indent + "    ";
	impl.getComponents().printCode(wr, nextIndex);
	wr.println(indent + "} " + name + ";");
    }

    public void printCompoundSummary(final PrintWriter wr) {
	impl.printCompoundSummary(wr);
    }

    public void printCompoundDetail(final PrintWriter wr) {
	impl.printCompoundDetail(wr);
    }

    public void printTexCompoundDetail(final PrintWriter wr) {
	impl.printTexCompoundDetail(wr);
    }

}
