/*
	$Id: Members.java 264 2006-08-18 21:19:31Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.util.LinkedList;
import java.io.PrintWriter;

/**
   ¤Τޤ϶ΤΥФΥåȤǤ
*/
public class Members implements Components {

    /** ФΥꥹ */
    private LinkedList<Member> v;

    /**
       ФΥåȤޤ

       @param gm 롼ץޥ͡
       @param type ΥФ°빽¤Τޤ϶Τη
       @param nodes memberǤΥΡɥꥹ
    */
    public Members(final GroupManager gm, final String type,
		   final NodeList nodes) {
	v = new LinkedList<Member>();

	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    Element elem = (Element) nodes.item(k);
	    v.add(gm.createMember(type, elem));
	}
    }

    public void printCode(final PrintWriter wr, final String indent) {
	for (Member m : v) {
	    m.printCode(wr, indent);
	}
    }

    public void printSummary(final PrintWriter wr) {
	for (Member m : v) {
	    m.printSummary(wr);
	}
    }

    public void printDetail(final PrintWriter wr) {
	for (Member m : v) {
	    wr.println("<hr>");
	    m.printDetail(wr);
	}
    }

    public void printTexDetail(final PrintWriter wr) {
	for (Member m : v) {
	    m.printTexDetail(wr);
	}
    }
}
