/*
	$Id: RegularMethods.java 252 2006-08-13 13:49:10Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import java.io.PrintWriter;

/**
   ؿΥåȤǤ
*/
public class RegularMethods extends Methods {

    /**
       ؿΥåȤޤ

       @param gm 롼ץޥ͡
       @param nodes ؿΥΡɥꥹ
    */
    public RegularMethods(final GroupManager gm, final NodeList nodes) {
	super(gm, nodes);
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	Options o = Options.getInstance();
	wr.println("");
	if (o.getCodeType().equals("c++")) {
	    wr.print(""
		     + "#if defined(__cplusplus)\n"
		     + "extern \"C\" {\n"
		     + "#endif\n"
		     + "\n");
	}
	for (Method m : v) {
	    m.printCode(wr);
	}
	if (o.getCodeType().equals("c++")) {
	    wr.print(""
		     + "\n"
		     + "#if defined(__cplusplus)\n"
		     + "}\n"
		     + "#endif\n");
	}
    }

    /**
       ֤ΥإåϤޤ

       @param wr 饤
    */
    public void printStubHeader(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println("");
	for (Method m : v) {
	    m.printStubHeader(wr);
	}
    }

    /**
       ֤ΥɤϤޤ

       @param wr 饤
    */
    public void printStubCode(final PrintWriter wr) {
	for (Method m : v) {
	    m.printStubCode(wr);
	}
    }

    /**
       {@inheritDoc}
    */
    @Override protected final Method createMethod(final GroupManager gm,
						  final Element elem) {
	return gm.createRegularMethod(elem);
    }

    /**
       {@inheritDoc}
    */
    @Override protected final void printSummaryHeader(final PrintWriter wr) {
	wr.println("<h2>Method Summary</h2>");
    }

    /**
       {@inheritDoc}
    */
    @Override protected final void printDetailHeader(final PrintWriter wr) {
	wr.println("<h2>Method Detail</h2>");
    }

    /**
       {@inheritDoc}
    */
    @Override protected final void printTexDetailHeader(final PrintWriter wr) {
	wr.println("\\Smethod");
    }
}
