/*
	$Id: Typedefs.java 261 2006-08-14 19:05:51Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.NodeList;
import org.w3c.dom.Element;
import java.util.LinkedList;
import java.io.PrintWriter;

/**
   ΥåȤǤ
*/
public class Typedefs {

    /** Υꥹ */
    private LinkedList<Typedef> v;

    /**
       ΥåȤޤ

       @param gm 롼ץޥ͡
       @param nodes ΥΡɥꥹ
    */
    public Typedefs(final GroupManager gm, final NodeList nodes) {
	v = new LinkedList<Typedef>();

	for (int k = 0, n = nodes.getLength(); k < n; ++k) {
	    v.add(gm.createTypedef((Element) nodes.item(k)));
	}
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println("");
	for (Typedef m : v) {
	    m.printCode(wr);
	}
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println(""
+ "    <h2>Typedef Summary</h2>\n"
+ "    <table width=\"100%\" cellspacing=\"0\" border=\"1\">");

	for (Typedef m : v) {
	    m.printSummary(wr);
	}

	wr.println(""
+ "    </table>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println(""
+ "    <h2>Typedef Detail</h2>");

	for (Typedef m : v) {
	    m.printDetail(wr);
	    wr.println("<hr>");
	}
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	if (v.size() == 0) {
	    return;
	}
	wr.println("\\Stypedef");

	for (Typedef m : v) {
	    m.printTexDetail(wr);
	}
    }
}
